//xsetaseta@gmail.com
//http://seta43.blogspot.com/
//MAXopV1
//Usar con GAMBAS 3 y MAX30105
//14/02/2020
//___________

char clave[] = "MAXOP";

#include <Wire.h>
#include "MAX30105.h"           //MAX3010x library
#include "heartRate.h"          //Heart rate calculating algorithm

MAX30105 particleSensor;

const byte RATE_SIZE = 4; //Increase this for more averaging. 4 is good.
byte rates[RATE_SIZE]; //Array of heart rates
byte rateSpot = 0;
long lastBeat = 0; //Time at which the last beat occurred
float beatsPerMinute;
int beatAvg;

bool pulso;
long dato;

int z, z1;
long valorMin, valorMinT;


int Oview = 1;
long valorDato = 1;

byte ledBrightness;
byte sampleAverage;
byte ledMode;
int sampleRate;
int pulseWidth;
int adcRange;


char entrada[100];
int  trozos[10];
int  trozosVal[10];
int contador;
boolean stringComplete = false;
char * puntero;

bool toneON;

long time1,time2;

void setReset(void)
{
    ledBrightness = 31; //Options: 0=Off to 255=50mA
    sampleAverage = 4; //Options: 1, 2, 4, 8, 16, 32
    ledMode = 3; //Options: 1 = Red only, 2 = Red + IR, 3 = Red + IR + Green
    sampleRate = 400; //Options: 50, 100, 200, 400, 800, 1000, 1600, 3200
    pulseWidth = 411; //Options: 69, 118, 215, 411
    adcRange = 4096; //Options: 2048, 4096, 8192, 16384
}

void setMAX(void)
{
  particleSensor.setup(ledBrightness, sampleAverage, ledMode, sampleRate, pulseWidth, adcRange);
  particleSensor.setPulseAmplitudeRed(0x0A); //Turn Red LED to low to indicate sensor is running
}

void setup()
{
  Serial.begin(115200);
  for (z = 0; z < 3; z++) { Serial.println(clave); delay(200); }

  particleSensor.begin(Wire, I2C_SPEED_FAST);  //Use default I2C port, 400kHz speed
  setReset(); setMAX();
  delay(500);
}

void loop()
{
  int  i;

  time2=millis()-time1;
  if (toneON==1 && time2>100)  { noTone(9); toneON=0;}

  while (Serial.available())
  {
    char inChar = (char)Serial.read();
    entrada[contador] = inChar;
    if (inChar == '\n')
    {
      stringComplete = true;
      entrada[contador] = 0;
    }
    contador++;
  }


  if (stringComplete)
  {
    Serial.println(entrada);
    for (z = 0; z < 10; z++)trozos[z] = 0;
    trozos[0] = 0;
    for (z = 0, i = 1; z < 100 && z < contador ; z++)
    {
      if (entrada[z] > 96 && entrada[z] < 123) entrada[z] -= 32; //mayusculas
      if (entrada[z] < 32) entrada[z] = 32;
      if (entrada[z] == ',' || entrada[z] == ' ' || entrada[z] == '.' )
      {
        entrada[z] = 0;
        trozos[i] = z + 1;
        trozosVal[i] = atol(entrada + trozos[i]);
        i++;
      }
    }

    for (z = 0; z < 10 ; z++)
    {
      if (trozos[z] == 0 && z != 0) break;
      puntero = entrada + trozos[z];
    }

    z = strlen(entrada);
    switch (z)
    {
      case 4:

        if (!strncmp(entrada, "LEDB", 4))
        {
          //          Serial.print("_LEDB"); Serial.print(" "); Serial.println(trozosVal[1]);
          ledBrightness = trozosVal[1]; setMAX();
          goto salir0;
        }
        if (!strncmp(entrada, "SAMA", 4))
        {
          sampleAverage = trozosVal[1];     setMAX();
          goto salir0;
        }
        if (!strncmp(entrada, "LEDM", 4))
        {
          ledMode = trozosVal[1];   setMAX();
          goto salir0;
        }
        if (!strncmp(entrada, "SAMR", 4))
        {
          sampleRate = trozosVal[1];  setMAX();
          goto salir0;
        }
        if (!strncmp(entrada, "PULW", 4))
        {
          pulseWidth = trozosVal[1];   setMAX();
          goto salir0;
        }
        if (!strncmp(entrada, "ADCR", 4))
        {
          adcRange = trozosVal[1];   setMAX();
          goto salir0;
        }

        if (!strncmp(entrada, "RESE", 4))
        {
          setReset(); setMAX();          
          goto salir0;
        }

        if (!strncmp(entrada, "VIEW", 4))
        {
          Oview = trozosVal[1];
          goto salir0;
        }
        if (!strncmp(entrada, "HELP", 4))
        {
          Serial.println("_____HELP_____");
          Serial.println(clave);
          goto salir0;
        }

        if (!strncmp(entrada, "VARI", 4))
        {
          Serial.println("_____VARIABLES_____");
          Serial.print("Oview="); Serial.println(Oview);
          Serial.print("ledBrightness="); Serial.println(ledBrightness);
          Serial.print("sampleAverage="); Serial.println(sampleAverage);
          Serial.print("ledMode="); Serial.println(ledMode);
          Serial.print("sampleRate="); Serial.println(sampleRate);
          Serial.print("pulseWidth="); Serial.println(pulseWidth);
          Serial.print("adcRange="); Serial.println(adcRange);
          goto salir0;
        }

    }
error0:
    Serial.print("ERROR ");  Serial.println(entrada);
salir0:
    //    Serial.println("______________");
    contador = 0;
    stringComplete = false;
    for (z = 0; z < 100 ; z++)entrada[z] = 0;
  }



  switch (Oview)
  {
    case  1:
      valorDato = particleSensor.getRed();
      break;
    case  2:
      valorDato = particleSensor.getIR();
      break;
    case  3:
      valorDato = particleSensor.getGreen();
      break;
  }


  //Also detecting a heartbeat
  if (valorDato > 7000)
  { //If a finger is detected
    if (checkForBeat(valorDato) == true)                        //If a heart beat is detected
    {
      pulso = 1;
      //      tone(9, 500);
      //      timePlay=0;
      //      delay(100);
      //      noTone(9);                                          //Deactivate the buzzer to have the effect of a "bip"
      //We sensed a beat!
      long delta = millis() - lastBeat;                   //Measure duration between two beats
      lastBeat = millis();

      beatsPerMinute = 60 / (delta / 1000.0);           //Calculating the BPM

      if (beatsPerMinute < 255 && beatsPerMinute > 20)               //To calculate the average we strore some values (4) then do some math to calculate the average
      {
        rates[rateSpot++] = (byte)beatsPerMinute; //Store this reading in the array
        rateSpot %= RATE_SIZE; //Wrap variable

        //Take average of readings
        beatAvg = 0;
        for (byte x = 0 ; x < RATE_SIZE ; x++)
          beatAvg += rates[x];
        beatAvg /= RATE_SIZE;
      }
    }

  }
  if (valorDato < 7000)
  {
    beatAvg = 0;
    //  Serial.println("No detectado, coloca el dedo");
    noTone(9);
  }

  dato = valorDato;

  dato = dato * -1;
  dato += 145000;

  z = dato - valorMinT;
  if (z > 2500)z = 2500;
  if (z < -500) z = -500;


  Serial.print(z);
  Serial.print(",");
  Serial.print(beatAvg);
  Serial.print(",");
  Serial.print(pulso);
  Serial.println("");


  if (pulso == 1) 
  {
    tone(9, 500);
    toneON=1;
    time1=millis();
  }

  pulso = 0;
  z1++;
  if (z1 > 20)
  {
    z1 = 0;
    valorMinT = (valorMin + valorMinT) / 2;
    valorMin = 300000;
  }
  if (dato < valorMin) valorMin = dato;

}
